跳转到主要内容

Using DHTMLX Scheduler Properties in VueScheduler

This page documents the public Vue wrapper surface for @dhtmlx/trial-vue-scheduler and @dhx/vue-scheduler.

Use it as a reference after Overview or Quick Start.

Available Props

PropTypeDescription
eventsArray<Event | SerializedEvent>Event collection rendered in the scheduler.
view"day" \| "week" \| "month" \| "year" \| ...Active Scheduler view.
dateDate | stringActive date used to render the selected view.
markersMarker[]Time markers (for example, non-working time blocks).
pluginsSchedulerPluginsEnables Scheduler plugins such as recurring, collision, timeline, units, tooltip, quick_info, etc. Pass as { recurring: true, collision: true }.
dataVueSchedulerDataConfig | nullData loading and change handling callbacks/URLs.
localestring | Record&lt;string, any&gt;Locale name or locale object. Defaults to "en".
themestringSkin name. Active skin: "terrace" (default)
templatesRecord<string, Function>Merged into scheduler.templates.
configSchedulerConfigMerged into scheduler.config.
xySchedulerXYUI sizing settings (for example, hiding built-in nav with nav_height: 0).
filter(event: Event) => booleanFilters events displayed in Scheduler.
modalsSchedulerModals | nullOverrides built-in delete confirmation dialogs.
eventBoxRendererEventBoxRenderer | nullCustom renderer for the event box element.
viewsSchedulerViewsPropRegisters configurations for the available views. Use TimelineViewConfig, UnitsViewConfig, or GridViewConfig shapes.
customLightboxComponent | nullCustom Vue event editor component.
templateWrapper(node: VNode) => VNodeWraps template Vue elements with app-level providers (for example, a ThemeProvider) to avoid flicker during server-side render.
on<EventName> listeners(...args) => anyVue listener props mapped to Scheduler events, for example :onBeforeLightbox or :onViewChange.

Data Collections And Synchronization

Use events props when Vue state is your source of truth:

<VueScheduler
:events="events"
/>

Sync behavior summary:

  • events updates are usually diff-based
  • the wrapper can switch to reset/re-parse for large changes

For model selection and callback strategy, see Data Binding and State Management Basics.

Config, Templates, Plugins, Theme, Locale

Use these props for Scheduler setup without imperative API calls.

<script setup lang="ts">
const config: SchedulerConfig = {
first_hour: 6,
last_hour: 22
};

const templates = {
event_text: (_start: Date, _end: Date, event: Event) => `#${event.id}: ${event.text}`
};
</script>

<template>
<VueScheduler
:config="config"
:templates="templates"
theme="terrace"
locale="en"
/>
</template>

Events, Lifecycle, And Instance Access

on<EventName>

Use Vue on<EventName> listener props for Scheduler events:

<script>
...
function beforeLightbox(eventId: string | number) {
// your custom code here
const event = schedulerRef.value?.instance?.getEvent(eventId);
if (event?.$new) {
return handleEventCreated(event);
}
return handleEditEvent(eventId);
}
...
</script>


<VueScheduler
:events="events"
:onBeforeLightbox="beforeLightbox"
@ready="handleReady"
/>

@ready

ready(instance) fires once after initialization and the first sync:

<VueScheduler :events="events" @ready="onReady" />

instance Via Component Ref

import { ref } from "vue";
import type { VueSchedulerRef } from "@dhtmlx/trial-vue-scheduler";

const schedulerRef = ref<VueSchedulerRef | null>(null);

function showAlert() {
schedulerRef.value?.instance?.alert({
title:"Alert",
type:"alert-error",
text:"You can't do this"
});
}

Use this for advanced operations that are not practical through props.

Data Transport: load, save, batchSave

data prop shape:

interface VueSchedulerDataConfig {
load?: string | ((scheduler: SchedulerStatic) => DataSet | Promise<DataSet>);
save?: string | RouterFunction;
batchSave?: (changes: BatchChanges) => void;
}

load

  • URL string -> scheduler.load(url)
  • Function -> returns a sync or async dataset

save

Per-change callback or router transport via dataProcessor.

batchSave

Grouped callback for high-volume updates:

const data = {
batchSave: changes => {
if (changes.events?.length) {
console.log("events changes", changes.events);
}
}
};

Use batchSave when one scheduler action can trigger many updates.

Customization Hooks

customLightbox

Replace the built-in event form UI with a Vue component.

modals

Override delete confirmations and call callback() to confirm deletion.

const modals = {
onBeforeEventDelete: ({ event, callback }) => {
if (window.confirm(`Delete event ${event.text}?`)) callback();
}
};

For practical examples, see Customization Patterns.

Filtering events

These props are often used together in advanced timeline views:

<script setup lang="ts">
...
const query = ref("");
const eventFilter = computed(() => {
const value = query.value.trim().toLowerCase();
return (event: any) => {
if (!value) {
return true;
}
return String(event.text || "").toLowerCase().includes(value);
};
});
</script>

<template>
<VueScheduler
...
:filter="eventFilter"
...
/>
</template>

Exported Helpers And Composables

The package exports both a default VueScheduler component export and named exports.

From @dhtmlx/trial-vue-scheduler or @dhx/vue-scheduler:

Type Exports

Import every type from the wrapper package itself (@dhx/vue-scheduler or @dhtmlx/trial-vue-scheduler). The wrapper bundles the underlying Scheduler engine and re-exports its types alongside the Vue-specific ones - there is no separate @dhx/scheduler package to install or import from.

Wrapper-owned types

ExportDescription
SerializedEventUser-facing event shape with Date | string dates. Use for store state, initial data, and save/batchSave payloads.
VueSchedulerRefType of the value exposed via component ref - { instance: SchedulerStatic | null }.
VueSchedulerDataConfigShape of the data prop (load, save, batchSave).
BatchChangesArgument passed to data.batchSave - grouped events changes.
DataCallbackChangeIndividual change entry inside a BatchChanges bucket - { entity, action, data, id }.
MarkerShape of items in the markers prop.
SchedulerModalsShape of the modals prop - onBeforeEventDelete and onRecurrenceConfirm callback signatures.
CustomLightboxPropsProps received by your customLightbox component (data, onSave, onCancel, onDelete, schedulerInstance).
VueSchedulerEventHandlersType of the events prop - known events plus string-keyed custom events.

Frequently used types from the Scheduler engine

The wrapper re-exports every type from the underlying Scheduler engine. The ones below come up most often in wrapper code - each row maps a core type to where it shows up in the Vue API.

ExportWhere it appears in wrapper code
EventRuntime event shapes (include $-prefixed properties). Used inside event handlers, template callbacks, and filter functions.
SchedulerStaticType of schedulerRef.value?.instance and the @ready argument.
SchedulerConfigOptionsShape of the object passed to the config prop.
SchedulerPluginsShape of the object passed to the plugins prop.

Every other type from the Scheduler engine is also exported from the wrapper - if you can import a name from @dhx/scheduler in the standalone library, you can import it from @dhx/vue-scheduler here.

Use SerializedEvent for data you own (Pinia state, ref<>, API responses, initial literals). Use Event for data scheduler owns (inside event handlers, template callbacks, filter functions), where runtime event objects include internal $-prefixed properties.

Composables

The wrapper exposes five composables that wrap common instance-side calls in a ref-aware, lifecycle-safe form. Each one takes a Ref<VueSchedulerRef | null> so it can wait for the instance to become available.

useSchedulerEvent(schedulerRef, eventName, handler)

Attaches a single Scheduler event with a lifecycle-safe lifetime. The handler is detached automatically on component unmount and re-attached if schedulerRef, eventName, or handler change. Returns { detach } for manual control.

import { useSchedulerEvent } from "@dhtmlx/trial-vue-scheduler";

const { detach } = useSchedulerEvent(schedulerRef, "onDblClick", id => {
console.log("dbl-click", id);
});

// Optional: detach early
// detach();

Use this when one-off listeners do not fit cleanly into the events map (for example listeners that need to update or unsubscribe based on local state).

useSchedulerActions(schedulerRef)

Returns wrapper-safe imperative actions:

MethodSignatureNotes
render()() => voidForces a redraw for bulk mutations.
exportToPDF(config?: ExportConfig)() => voidRequires plugins: { export_api: true }. Pass exporter options through config.
exportToPNG(config?: ExportConfig)() => voidRequires plugins: { export_api: true }. Pass exporter options through config.
exportToExcel(config?)(config?: object) => voidRequires plugins: { export_api: true }. Pass exporter options through config.
exportToICal(config?: ExportConfig)() => voidRequires plugins: { export_api: true }. Pass exporter options through config.
import { ref } from "vue";
import { useSchedulerActions, type VueSchedulerRef } from "@dhtmlx/trial-vue-scheduler";

const schedulerRef = ref<VueSchedulerRef | null>(null);
const actions = useSchedulerActions(schedulerRef);

const exportPdf = () => actions.exportToPDF();
const exportExcel = () => actions.exportToExcel();
Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

跳转到主要内容

Using DHTMLX Scheduler Properties in ReactScheduler

This page describes the props accepted by React Scheduler and how they map to DHTMLX Scheduler APIs.

Available props

PropTypeDescription
eventsEvent[]Scheduler events to render.
view"day" | "week" | "month" | "year" | ...Active Scheduler view.
dateDateActive date used to render the selected view.
markersMarker[]Time markers (for example, non-working time blocks).
pluginsSchedulerPluginsEnables Scheduler plugins such as recurring, collision, timeline, units, tooltip, quick_info, etc. Pass as { recurring: true, collision: true }.
data{ load?: string | (() => Promise<any>); save?: string | SaveHandler; batchSave?: BatchSaveHandler }Data loading and change handling callbacks/URLs.
localestring | LocaleActive locale (for example, "en", "es"). Defaults to "en".
themestringActive skin: "terrace" (default), "dark", "material", "flat", "contrast_black", "contrast_white".
templatesSchedulerTemplatesMaps to Scheduler templates (for example, event style/text rendering).
configSchedulerConfigMaps to Scheduler configuration options.
xyRecord<string, number>UI sizing settings (for example, hiding built-in nav with nav_height: 0).
filter(event: Event) => booleanFilters events displayed in Scheduler.
modalsSchedulerModalsOverrides built-in confirmation dialogs (for example, event delete and recurrence confirmation).
eventBoxRendererEventBoxRenderer | nullCustom renderer for the event box element.
viewsany[]Registers configurations for the available views. Use TimelineViewConfig, UnitsViewConfig, or GridViewConfig shapes.
customViewsany[]Registers user-defined view definitions.
customLightboxReactElement | nullReplaces built-in Lightbox with your React component.
templateWrapper(element: ReactElement) => ReactElementWraps template React elements with app-level providers (for example, a ThemeProvider) to avoid flicker during server-side render.
on<EventName> props(...args) => anyEvent handlers mapped to Scheduler events (onViewChange, onBeforeLightbox, etc.).

Basic example

import ReactScheduler, {
type Event,
type SchedulerConfig,
type SchedulerTemplates,
} from "@dhtmlx/trial-react-scheduler";
import "@dhtmlx/trial-react-scheduler/dist/react-scheduler.css";

const events: Event[] = [
{
id: 1,
text: "Planning",
start_date: new Date("2025-12-08T09:00:00Z"),
end_date: new Date("2025-12-08T10:00:00Z"),
},
];

const templates: SchedulerTemplates = {
event_class: (_start, _end, event) => event.classname || "",
};

const config: SchedulerConfig = {
first_hour: 6,
last_hour: 22,
hour_size_px: 60,
};

export default function Demo() {
return (
<ReactScheduler
events={events}
view="week"
date={new Date("2025-12-08T00:00:00Z")}
templates={templates}
config={config}
/>
);
}

Data prop (load, save, batchSave)

Use the data prop to connect Scheduler to your backend or to React-managed state.

Using backend URLs

<ReactScheduler
data={{
load: "/api/scheduler/load",
save: "/api/scheduler/save",
}}
/>

Using callback handlers

<ReactScheduler
data={{
save: async (entity, action, item, id) => {
if (entity !== "event") return;

if (action === "create") {
const response = await fetch("/api/events", {
method: "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(item),
});

const created = await response.json();
return { id: created.id };
}

if (action === "update") {
await fetch(`/api/events/${id}`, {
method: "PUT",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(item),
});
}

if (action === "delete") {
await fetch(`/api/events/${id}`, { method: "DELETE" });
}
},
}}
/>

Template and config mapping

templates maps to Scheduler template functions, while config maps to Scheduler configuration options.

<ReactScheduler
templates={{
event_class: (_start, _end, event) =>
event.classname === "important" ? "event-important" : "",
}}
config={{
first_hour: 7,
last_hour: 21,
time_step: 15,
}}
/>

Event props

You can pass Scheduler events as React props.

<ReactScheduler
onViewChange={(mode, date) => {
console.log("View changed:", mode, date);
}}
onBeforeLightbox={(eventId) => {
console.log("Opening editor for", eventId);
return true;
}}
/>

For the full list of supported events and callbacks, see:

customLightbox and modals

Use customLightbox when you want to replace the built-in event editor with your own React component. Use modals when you want custom confirmation dialogs.

<ReactScheduler
customLightbox={<MyLightbox />}
modals={{
onBeforeEventDelete: ({ event, callback }) => {
if (window.confirm(`Delete "${event.text}"?`)) {
callback();
}
},
}}
/>

Filtering events

<ReactScheduler
events={events}
filter={(event) => event.text.toLowerCase().includes(search.toLowerCase())}
/>

Direct API access through ref

If a use case is not covered by props, use a ref to get the underlying Scheduler instance.

import { useEffect, useRef } from "react";
import ReactScheduler, { type ReactSchedulerRef } from "@dhx/react-scheduler";

export default function DirectApiDemo() {
const schedulerRef = useRef<ReactSchedulerRef>(null);

useEffect(() => {
const scheduler = schedulerRef.current?.instance;
if (!scheduler) return;

console.log(scheduler.getEvents());
scheduler.setCurrentView(new Date());
}, []);

return <ReactScheduler ref={schedulerRef} events={[]} />;
}
Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.